88x2bu-20210702/install-driver.sh

357 lines
11 KiB
Bash
Raw Normal View History

2023-01-27 10:16:08 -06:00
#!/bin/sh
2021-10-27 12:51:22 -05:00
# Purpose: Install Realtek out-of-kernel USB WiFi adapter drivers.
2022-08-21 15:31:50 -05:00
#
# Supports dkms and non-dkms installations.
2023-01-27 10:16:08 -06:00
#
# To make this file executable:
#
# $ chmod +x edit-options.sh
#
# To execute this file:
#
# $ sudo ./edit-options.sh
#
2023-01-09 12:27:31 -06:00
# Copyright(c) 2023 Nick Morrow
2022-12-20 23:53:39 -06:00
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
2021-10-27 12:51:22 -05:00
SCRIPT_NAME="install-driver.sh"
2023-01-27 10:16:08 -06:00
SCRIPT_VERSION="20230126"
MODULE_NAME="88x2bu"
2022-12-04 15:21:08 -06:00
DRV_VERSION="5.13.1"
KVER="$(uname -r)"
2022-12-04 15:21:08 -06:00
KARCH="$(uname -m)"
MODDESTDIR="/lib/modules/${KVER}/kernel/drivers/net/wireless/"
2022-12-04 15:21:08 -06:00
DRV_NAME="rtl${MODULE_NAME}"
2021-10-27 12:51:22 -05:00
DRV_DIR="$(pwd)"
2022-12-20 23:53:39 -06:00
OPTIONS_FILE="${MODULE_NAME}.conf"
2022-10-19 16:15:30 -05:00
2023-01-27 10:16:08 -06:00
# check to ensure sudo was used to start the script
if [ "$(id -u)" -ne 0 ]; then
echo "You must run this script with superuser (root) privileges."
echo "Try: \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2023-01-27 10:16:08 -06:00
# support for the NoPrompt option allows non-interactive use of this script
NO_PROMPT=0
# get the script options
while [ $# -gt 0 ]
do
case $1 in
NoPrompt)
NO_PROMPT=1 ;;
*h|*help|*)
echo "Syntax $0 <NoPrompt>"
echo " NoPrompt - noninteractive mode"
echo " -h|--help - Show help"
exit 1
;;
esac
shift
done
2022-12-20 23:53:39 -06:00
# ensure /usr/sbin is in the PATH so iw can be found
if ! echo "$PATH" | grep -qw sbin; then
export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
fi
# check to ensure gcc is installed
2023-01-27 10:16:08 -06:00
if ! command -v gcc >/dev/null 2>&1; then
2022-12-30 15:14:47 -06:00
echo "A required package is not installed."
2022-12-20 23:53:39 -06:00
echo "Please install the following package: gcc"
2022-12-07 09:39:21 -06:00
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2022-12-20 23:53:39 -06:00
# check to ensure make is installed
2023-01-27 10:16:08 -06:00
if ! command -v make >/dev/null 2>&1; then
2022-12-30 15:14:47 -06:00
echo "A required package is not installed."
2022-12-20 23:53:39 -06:00
echo "Please install the following package: make"
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2023-01-27 10:16:08 -06:00
# check to see if the correct header files are installed
2022-12-20 23:53:39 -06:00
if [ ! -d "/lib/modules/$(uname -r)/build" ]; then
2022-12-30 15:14:47 -06:00
echo "Your kernel header files aren't properly installed."
2023-01-27 10:16:08 -06:00
echo "Please consult your distro documentation or user support forums."
echo "Once the header files are properly installed, please run \"sudo ./${SCRIPT_NAME}\""
2022-12-20 23:53:39 -06:00
exit 1
fi
# check to ensure iw is installed
2023-01-27 10:16:08 -06:00
if ! command -v iw >/dev/null 2>&1; then
2022-12-30 15:14:47 -06:00
echo "A required package is not installed."
2022-12-20 23:53:39 -06:00
echo "Please install the following package: iw"
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
# check to ensure rfkill is installed
2023-01-27 10:16:08 -06:00
if ! command -v rfkill >/dev/null 2>&1; then
2022-12-30 15:14:47 -06:00
echo "A required package is not installed."
echo "Please install the following package: rfkill"
echo "Once the package is installed, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
fi
2023-01-27 10:16:08 -06:00
DEFAULT_EDITOR="$(cat default-editor.txt)"
# try to find the user's default text editor through the EDITORS_SEARCH array
for TEXT_EDITOR in "${VISUAL}" "${EDITOR}" "${DEFAULT_EDITOR}" vi; do
command -v "${TEXT_EDITOR}" >/dev/null 2>&1 && break
done
# fail if no editor was found
if ! command -v "${TEXT_EDITOR}" >/dev/null 2>&1; then
echo "No text editor found (default: ${DEFAULT_EDITOR})."
echo "Please install ${DEFAULT_EDITOR} or edit the file 'default-editor.txt' to specify your editor."
echo "Once complete, please run \"sudo ./${SCRIPT_NAME}\""
exit 1
2022-12-20 23:53:39 -06:00
fi
2023-01-27 10:16:08 -06:00
echo ": ---------------------------"
2021-10-27 12:51:22 -05:00
# displays script name and version
2023-01-10 16:09:36 -06:00
echo ": ${SCRIPT_NAME} v${SCRIPT_VERSION}"
2023-01-09 12:27:31 -06:00
# information that helps with bug reports
# display architecture
2023-01-27 10:16:08 -06:00
echo ": ${KARCH} (architecture)"
SMEM=$(LANG=C free | awk '/Mem:/ { print $2 }')
sproc=$(nproc)
# avoid Out of Memory condition in low-RAM systems by limiting core usage
if [ "$sproc" -gt 1 ]; then
if [ "$SMEM" -lt 1400000 ]
then
sproc=2
fi
fi
2023-01-09 12:27:31 -06:00
2023-01-27 10:16:08 -06:00
# display number of in-use processing units / total processing units
echo ": ${sproc}/$(nproc) (in-use/total processing units)"
# display total system memory
echo ": ${SMEM} (total system memory)"
2023-01-09 12:27:31 -06:00
# display kernel version
2023-01-27 10:16:08 -06:00
echo ": ${KVER} (kernel version)"
2023-01-09 12:27:31 -06:00
# display gcc version
gcc_ver=$(gcc --version | grep -i gcc)
2023-01-27 10:16:08 -06:00
echo ": ""${gcc_ver}"
2023-01-09 12:27:31 -06:00
2023-01-09 18:16:40 -06:00
# display dkms version if installed
2023-01-27 10:16:08 -06:00
if command -v dkms >/dev/null 2>&1; then
2023-01-09 18:16:40 -06:00
dkms_ver=$(dkms --version)
2023-01-27 10:16:08 -06:00
echo ": ""${dkms_ver}"
2023-01-09 12:27:31 -06:00
fi
2023-01-09 18:16:40 -06:00
# display secure mode status if mokutil is installed
2023-01-27 10:16:08 -06:00
if command -v mokutil >/dev/null 2>&1; then
2023-01-09 18:16:40 -06:00
sb_state=$(mokutil --sb-state)
2023-01-27 10:16:08 -06:00
echo ": ""${sb_state}"
2023-01-09 12:27:31 -06:00
fi
2023-01-27 10:16:08 -06:00
# needs work
2023-01-09 12:27:31 -06:00
# display ISO 3166-1 alpha-2 Country Code
#a2_country_code=$(iw reg get | grep -i country)
2023-01-27 10:16:08 -06:00
#echo ": Location: ""${a2_country_code}"
2023-01-09 12:27:31 -06:00
#if [[ $a2_country_code == *"00"* ]];
#then
# echo "The Country Code may not be properly set."
# echo "File alpha-2_Country_Codes is located in the driver directory."
# echo "Please read and follow the directions in the file after installation."
#fi
2021-10-27 12:51:22 -05:00
2023-01-27 10:16:08 -06:00
echo ": ---------------------------"
2022-12-30 15:14:47 -06:00
# check for and remove non-dkms installations
# standard naming
2023-01-27 10:16:08 -06:00
if [ -f "${MODDESTDIR}${MODULE_NAME}.ko" ]; then
2022-12-30 15:14:47 -06:00
echo "Removing a non-dkms installation: ${MODDESTDIR}${MODULE_NAME}.ko"
2023-01-27 10:16:08 -06:00
rm -f "${MODDESTDIR}"${MODULE_NAME}.ko
/sbin/depmod -a "${KVER}"
2023-01-09 12:27:31 -06:00
echo "Removing ${OPTIONS_FILE} from /etc/modprobe.d"
rm -f /etc/modprobe.d/${OPTIONS_FILE}
echo "Removing source files from /usr/src/${DRV_NAME}-${DRV_VERSION}"
rm -rf /usr/src/${DRV_NAME}-${DRV_VERSION}
make clean >/dev/null 2>&1
2021-10-27 12:51:22 -05:00
fi
2022-12-30 15:14:47 -06:00
# check for and remove non-dkms installations
# with rtl added to module name (PClinuxOS)
2023-01-27 10:16:08 -06:00
if [ -f "${MODDESTDIR}rtl${MODULE_NAME}.ko" ]; then
2022-12-30 15:14:47 -06:00
echo "Removing a non-dkms installation: ${MODDESTDIR}rtl${MODULE_NAME}.ko"
2023-01-27 10:16:08 -06:00
rm -f "${MODDESTDIR}"rtl${MODULE_NAME}.ko
/sbin/depmod -a "${KVER}"
2023-01-09 12:27:31 -06:00
echo "Removing ${OPTIONS_FILE} from /etc/modprobe.d"
rm -f /etc/modprobe.d/${OPTIONS_FILE}
echo "Removing source files from /usr/src/${DRV_NAME}-${DRV_VERSION}"
rm -rf /usr/src/${DRV_NAME}-${DRV_VERSION}
make clean >/dev/null 2>&1
2022-12-30 15:14:47 -06:00
fi
# check for and remove non-dkms installations
# with compressed module in a unique non-standard location (Armbian)
# Example: /usr/lib/modules/5.15.80-rockchip64/kernel/drivers/net/wireless/rtl8821cu/8821cu.ko.xz
# Dear Armbiam, this is a really bad idea.
2023-01-27 10:16:08 -06:00
if [ -f "/usr/lib/modules/${KVER}/kernel/drivers/net/wireless/${DRV_NAME}/${MODULE_NAME}.ko.xz" ]; then
2022-12-30 15:14:47 -06:00
echo "Removing a non-dkms installation: /usr/lib/modules/${KVER}/kernel/drivers/net/wireless/${DRV_NAME}/${MODULE_NAME}.ko.xz"
2023-01-27 10:16:08 -06:00
rm -f /usr/lib/modules/"${KVER}"/kernel/drivers/net/wireless/${DRV_NAME}/${MODULE_NAME}.ko.xz
/sbin/depmod -a "${KVER}"
2023-01-09 12:27:31 -06:00
echo "Removing ${OPTIONS_FILE} from /etc/modprobe.d"
rm -f /etc/modprobe.d/${OPTIONS_FILE}
echo "Removing source files from /usr/src/${DRV_NAME}-${DRV_VERSION}"
rm -rf /usr/src/${DRV_NAME}-${DRV_VERSION}
make clean >/dev/null 2>&1
2022-12-30 15:14:47 -06:00
fi
2023-01-09 12:27:31 -06:00
# check for and remove dkms installations
2023-01-27 10:16:08 -06:00
if command -v dkms >/dev/null 2>&1; then
if dkms status | grep -i ${DRV_NAME}; then
2023-01-09 12:27:31 -06:00
echo "Removing a dkms installation: ${DRV_NAME}"
dkms remove -m ${DRV_NAME} -v ${DRV_VERSION} --all
echo "Removing ${OPTIONS_FILE} from /etc/modprobe.d"
rm -f /etc/modprobe.d/${OPTIONS_FILE}
echo "Removing source files from /usr/src/${DRV_NAME}-${DRV_VERSION}"
rm -rf /usr/src/${DRV_NAME}-${DRV_VERSION}
2022-12-20 23:53:39 -06:00
fi
fi
# sets module parameters (driver options) and blacklisted modules
2022-12-30 15:14:47 -06:00
echo "Installing ${OPTIONS_FILE} to /etc/modprobe.d"
2021-10-27 12:51:22 -05:00
cp -f ${OPTIONS_FILE} /etc/modprobe.d
# determine if dkms is installed and run the appropriate routines
2023-01-27 10:16:08 -06:00
if ! command -v dkms >/dev/null 2>&1; then
echo "The non-dkms installation routines are in use."
2022-08-21 15:31:50 -05:00
2022-12-04 15:21:08 -06:00
make clean >/dev/null 2>&1
2021-10-27 12:51:22 -05:00
2023-01-27 10:16:08 -06:00
make -j"$(nproc)"
RESULT=$?
2021-10-27 12:51:22 -05:00
2023-01-27 10:16:08 -06:00
if [ "$RESULT" != "0" ]; then
2022-12-30 15:14:47 -06:00
echo "An error occurred: ${RESULT}"
echo "Please report this error."
2022-12-30 15:14:47 -06:00
echo "Please copy all screen output and paste it into the problem report."
echo "You will need to run the following before reattempting installation."
2022-11-26 19:16:35 -06:00
echo "$ sudo ./remove-driver.sh"
exit $RESULT
fi
2021-10-27 12:51:22 -05:00
# As shown in Makefile
# install:
# install -p -m 644 $(MODULE_NAME).ko $(MODDESTDIR)
# /sbin/depmod -a ${KVER}
make install
RESULT=$?
2021-10-27 12:51:22 -05:00
2023-01-27 10:16:08 -06:00
if [ "$RESULT" = "0" ]; then
2022-12-20 23:53:39 -06:00
make clean >/dev/null 2>&1
echo "The driver was installed successfully."
else
2022-12-30 15:14:47 -06:00
echo "An error occurred: ${RESULT}"
echo "Please report this error."
2022-12-30 15:14:47 -06:00
echo "Please copy all screen output and paste it into the problem report."
echo "You will need to run the following before reattempting installation."
2022-11-26 19:16:35 -06:00
echo "$ sudo ./remove-driver.sh"
exit $RESULT
fi
else
echo "The dkms installation routines are in use."
2021-10-27 12:51:22 -05:00
# the dkms add command requires source in /usr/src/${DRV_NAME}-${DRV_VERSION}
2022-12-30 15:14:47 -06:00
echo "Copying source files to /usr/src/${DRV_NAME}-${DRV_VERSION}"
cp -rf "${DRV_DIR}" /usr/src/${DRV_NAME}-${DRV_VERSION}
2022-12-30 15:14:47 -06:00
dkms add -m ${DRV_NAME} -v ${DRV_VERSION}
RESULT=$?
2021-10-27 12:51:22 -05:00
2022-10-19 16:15:30 -05:00
# RESULT will be 3 if the DKMS tree already contains the same module/version
# combo. You cannot add the same module/version combo more than once.
2023-01-27 10:16:08 -06:00
if [ "$RESULT" != "0" ]; then
if [ "$RESULT" = "3" ]; then
2022-12-20 23:53:39 -06:00
echo "This driver may already be installed."
2022-12-04 15:21:08 -06:00
echo "Run the following and then reattempt installation."
echo "$ sudo ./remove-driver.sh"
2022-12-30 15:14:47 -06:00
exit $RESULT
2022-12-04 15:21:08 -06:00
else
2022-12-30 15:14:47 -06:00
echo "An error occurred. dkms add error: ${RESULT}"
2022-12-04 15:21:08 -06:00
echo "Please report this error."
2022-12-30 15:14:47 -06:00
echo "Please copy all screen output and paste it into the problem report."
2022-12-04 15:21:08 -06:00
echo "Run the following before reattempting installation."
echo "$ sudo ./remove-driver.sh"
exit $RESULT
fi
else
2022-12-20 23:53:39 -06:00
echo "The driver was added to dkms successfully."
fi
2023-01-27 10:16:08 -06:00
if command -v /usr/bin/time >/dev/null 2>&1; then
2022-12-30 15:14:47 -06:00
/usr/bin/time -f "Compile time: %U seconds" dkms build -m ${DRV_NAME} -v ${DRV_VERSION}
else
dkms build -m ${DRV_NAME} -v ${DRV_VERSION}
fi
RESULT=$?
2023-01-27 10:16:08 -06:00
if [ "$RESULT" != "0" ]; then
2022-12-30 15:14:47 -06:00
echo "An error occurred. dkms build error: ${RESULT}"
echo "Please report this error."
2022-12-30 15:14:47 -06:00
echo "Please copy all screen output and paste it into the problem report."
echo "Run the following before reattempting installation."
echo "$ sudo ./remove-driver.sh"
exit $RESULT
2022-12-04 15:21:08 -06:00
else
2022-12-20 23:53:39 -06:00
echo "The driver was built by dkms successfully."
fi
dkms install -m ${DRV_NAME} -v ${DRV_VERSION}
RESULT=$?
2023-01-27 10:16:08 -06:00
if [ "$RESULT" != "0" ]; then
2022-12-30 15:14:47 -06:00
echo "An error occurred. dkms install error: ${RESULT}"
echo "Please report this error."
2022-12-30 15:14:47 -06:00
echo "Please copy all screen output and paste it into the problem report."
echo "Run the following before reattempting installation."
echo "$ sudo ./remove-driver.sh"
exit $RESULT
2022-12-04 15:21:08 -06:00
else
2022-12-20 23:53:39 -06:00
echo "The driver was installed by dkms successfully."
fi
fi
2021-10-27 12:51:22 -05:00
2021-12-14 07:09:23 -06:00
# unblock wifi
2023-01-27 10:16:08 -06:00
if command -v rfkill >/dev/null 2>&1; then
rfkill unblock wlan
else
2022-12-30 15:14:47 -06:00
echo "Unable to run $ rfkill unblock wlan"
fi
2021-10-27 12:51:22 -05:00
2022-12-30 15:14:47 -06:00
# if NoPrompt is not used, ask user some questions
2023-01-27 10:16:08 -06:00
if [ $NO_PROMPT -ne 1 ]; then
printf "Do you want to edit the driver options file now? [y/N] "
read -r REPLY
case "$REPLY" in
[yY]*) ${TEXT_EDITOR} /etc/modprobe.d/${OPTIONS_FILE} ;;
esac
2021-10-27 12:51:22 -05:00
2023-01-27 10:16:08 -06:00
printf "Do you want to apply the new options by rebooting now? (recommended) [y/N] "
read -r REPLY
case "$REPLY" in
[yY]*) reboot ;;
esac
2021-10-27 12:51:22 -05:00
fi